//
//  ViewController.m
//  Talk
//
//  Created by YeTao on 2016/12/12.
//  Copyright © 2016年 ungacy. All rights reserved.
//

#import "ViewController.h"
#import "Person.pb.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self proto];
    [self json];
    // Do any additional setup after loading the view, typically from a nib.
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void) proto
{
    // Proto Part

    NSLog(@"%@ %lu %lu %lu %lu",(sizeof(long) == 8 ? @"USING 64 bit system" : @"USING 32 bit system"),sizeof(int32_t), sizeof(long), sizeof(long long), sizeof(int64_t));

    NSData* raw_data = [NSData dataWithContentsOfURL:[NSURL URLWithString:@"http://127.0.0.1:4567/1/getGroups"]];
    if (!raw_data)
    {
        NSLog(@"Please turn on the server");
        return;
    }

    __block Person* person;
    NSLog(@"proto content size %@",[NSByteCountFormatter stringFromByteCount:raw_data.length countStyle:NSByteCountFormatterCountStyleMemory]);

    person = [Person parseFromData:raw_data];
    NSLog(@"%ld",(long)person.id);
}

-(void) json
{
    // JSON Part
    NSData *raw_data = [NSData dataWithContentsOfURL:[NSURL URLWithString:@"http://127.0.0.1:4567/1/getGroupsJson"]];

    if (!raw_data)
    {
        NSLog(@"Please turn on the server");
        return;
    }

    NSLog(@" ");
    NSLog(@"json content size %@",[NSByteCountFormatter stringFromByteCount:raw_data.length countStyle:NSByteCountFormatterCountStyleMemory]);
    __block NSObject *serial;
    serial = [NSJSONSerialization JSONObjectWithData:raw_data options:NSJSONReadingMutableContainers error:nil];
}


@end
